from enum import Enum

class CoSigners(Enum):
    NONE = 'NONE'
    EULITH = 'EULITH'
    FIREBLOCKS = 'FIREBLOCKS'

class ActionType(Enum):
    APPROVE = 'APPROVE'
    WRAP = 'WRAP'
    UNWRAP = 'UNWRAP'
    TRANSFER = 'TRANSFER'
    SWAP = 'SWAP'
    OPEN_LP_POSITION = 'OPEN_LP_POSITION'
    CLOSE_LP_POSITION = 'CLOSE_LP_POSITION'
    PROPOSE_VAULT_VALUATION = 'PROPOSE_VAULT_VALUATION'
    SETTLE_VAULT_DEPOSIT = 'SETTLE_VAULT_DEPOSIT'
    SETTLE_VAULT_REDEEM = 'SETTLE_VAULT_REDEEM'

class TransactionType(Enum):
    APPROVE = 'APPROVE'
    WRAP = 'WRAP'
    UNWRAP = 'UNWRAP'
    TRANSFER = 'TRANSFER'
    SWAP = 'SWAP'
    MINT = 'MINT'
    BURN = 'BURN'
    COLLECT = 'COLLECT'
    INCREASE_LIQUIDITY = 'INCREASE_LIQUIDITY'
    DECREASE_LIQUIDITY = 'DECREASE_LIQUIDITY'
    CLOSE_POSITION_MULTICALL = 'CLOSE_POSITION_MULTICALL'
    PROPOSE_VAULT_VALUATION = 'PROPOSE_VAULT_VALUATION'
    SETTLE_VAULT_DEPOSIT = 'SETTLE_VAULT_DEPOSIT'
    SETTLE_VAULT_REDEEM = 'SETTLE_VAULT_REDEEM'

class SwapSide(Enum):
    BUY = 'BUY'
    SELL = 'SELL'

class Chain(Enum):
    ETHEREUM = 'ETHEREUM'
    ARBITRUM = 'ARBITRUM'
    OPTIMISM = 'OPTIMISM'
    BASE = 'BASE'

class Protocol(Enum):
    UNISWAP_V3 = 'UNISWAP_V3'
    VAULT = 'VAULT'
    ENSO = 'ENSO'

class Network(Enum):
    MAINNET = 'MAINNET'
    ANVIL = 'ANVIL'
    SEPOLIA = 'SEPOLIA'

class ExecutionStatus(Enum):
    CREATED = 'CREATED'
    BUILT = 'BUILT'
    SIGNED = 'SIGNED'
    PRE_SEND = 'PRE_SEND'
    SENT = 'SENT'
    SUCCESS = 'SUCCESS'
    FAILED = 'FAILED'
    NOT_INCLUDED = 'NOT_INCLUDED'
    CANCELLED = 'CANCELLED'
    PARTIAL_EXECUTION = 'PARTIAL_EXECUTION'
    RECEIPT_UNKNOWN = 'RECEIPT_UNKNOWN'
    RECEIPT_PARSED_FAILURE = 'RECEIPT_PARSED_FAILURE'
    UNKNOWN = 'UNKNOWN'
